const UserModel = require('../models/UserModel') // مسیر درست به مدل کاربر
const jwt = require('jsonwebtoken')

module.exports = async (req, res, next) => {
  try {
    if (!('authorization' in req.headers)) {
      return res.status(401).send({
        status: 'error',
        code: 401,
        message: 'You are not authorized!'
      })
    }

    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)

    if (!decodedToken) {
      return res.status(401).send({
        status: 'error',
        code: 401,
        message: 'Your token is not valid!'
      })
    }

    const user = await UserModel.findById(decodedToken.id)
    if (!user.user_name ||
      !user.first_name ||
      !user.last_name ||
      !user.password) {
    return res.status(403).send({
      status: 'error',
      code: 403,
      message: 'لطفا از بخش تنظیمات، ثبت نام خود را کامل کنید',
      type: 'not_register'
    })
  }
  

    req.user = user // کاربر را به درخواست اضافه کنید تا در سایر middleware ها و کنترلرها استفاده شود.
    next()
  } catch (error) {
    console.error('not_register middleware:', error)
    res.status(500).send({
      status: 'error',
      code: 500,
      message: 'Server error'
    })
  }
}
